version: '3.9'


# Environment variables for containers that do ROS communication
# In this sample code, we're using localhost for both, since all is running on the same machine (and on host's network)
x-ros-env: &x-ros-env
  # First they need to know their roscore machine
  ROS_MASTER_URI: http://127.0.0.1:11311/
  # And second they need to know their own hostname/IP
  ROS_HOSTNAME: 127.0.0.1

# Environment variables for display access. This is required for GUI's
x-host-display-env: &x-host-display-env
  DISPLAY: $DISPLAY
  NVIDIA_VISIBLE_DEVICES: all
  NVIDIA_DRIVER_CAPABILITIES: all

# Bind mount mapping for display access
x-host-display-volume: &x-host-display-volume
  # This gives XAuthority access same as the current user (on host system) to the user inside
  "$HOME/.Xauthority:/root/.Xauthority"


# Bind mount for GPU access
x-gpu-config-volumes: &x-gpu-config-volumes
  # We're not really specific here. Just give access to all devices... :)
  "/dev:/dev"

# Deploy config for GPU access
x-gpu-config-deploy: &x-gpu-config-deploy
  resources:
    reservations:
      devices:
        - driver: nvidia
          count: all
          capabilities: [gpu]

services:
  gazebo:
    image: registry.gitlab.com/autonomous-systems-lab/libraries/docker-robotic/panda-simulator:noetic-20.04

    container_name: panda-simulator
    network_mode: host
    privileged: true


    environment:
      <<: *x-ros-env          # We do need access to ROS, so we need those env variables
      <<: *x-host-display-env

    volumes:
      - *x-host-display-volume
      - *x-gpu-config-volumes

    deploy:
      *x-gpu-config-deploy


    # wait until roscore has started, source ros and then launch the franka service
    #command: bash -c "roslaunch gazebo_ros empty_world.launch"
